// Fragment Shader
#version 330 core

in vec2 uv;
in vec3 pos_m;

in vec3 E_ts;
in vec3 T;
in vec3 B;
in vec3 N;
in vec3 E_w;


uniform mat4 M;

uniform samplerCube cubemap;
uniform vec3 color;
uniform sampler2D texture_bump;
uniform int functionType;
uniform vec3 sin_frequencies;

layout (location=0) out vec4 fragColor;

vec3 sinus(vec3 N)
{
	//N.z = (1+sin((pos.x-pos.y)*80))/2;
	N.x += sin(pos_m.x*sin_frequencies.x);
	N.y += sin(pos_m.y*sin_frequencies.y);
	N.z += sin(pos_m.z*sin_frequencies.z);
	//N = normalize( vec3(sin(pos.x), cos(pos.y), pos.z));

	return normalize(N);
}

void main()
{
	//tangent to modelspace
	mat3 TBNmodel = mat3(normalize( T) ,
	normalize(B) ,
	normalize(N) );

	//bumpmap lookup (normal in tangentspace)
	vec3 N_ts =normalize(  texture2D(texture_bump, uv).rgb * 2.0 - 1.0 );
    
	if (functionType == 0)
	{
		//do nothing
	}
	else if (functionType == 1) {
		N_ts = sinus(N_ts);
	}

	//normal in worldspace
	vec3 N_w = normalize(mat3(M) * TBNmodel * N_ts);

	//reflection in world space
	vec3 R_w = reflect ( normalize(E_w), N_w );

	//cubemap lookup	
	R_w = vec3(-R_w.x, R_w.yz); //x flipped
	fragColor = texture(cubemap, R_w) * vec4(color,1);

	//Debug
	//fragColor = vec4(N_w,1);
	//fragColor = vec4(test,1);
} 