// Vertex Shader
#version 330 core

in vec3 in_position;

uniform vec3 cameraPosition;

uniform mat4 V;//view matrix
uniform mat4 P;//projection matrix

out vec3 texCoord;

void main()
{
    gl_Position = P * V * vec4(in_position + cameraPosition, 1.0); //skybox frame moves with camera
    //texCoord = in_position;
	texCoord = vec3(in_position.x, -in_position.yz); //note -y because in opengl cubemap orientation
} 